"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.watch = exports.props = void 0;
var props = {
  props: {
    min: {
      type: Number,
      default: 0
    },
    max: {
      type: Number,
      default: 10
    },
    step: {
      type: Number,
      default: 1
    },
    precision: {
      type: Number
    },
    orientation: {
      type: String,
      default: 'horizontal'
    },
    value: {
      type: [Number, Array],
      default: function _default() {
        return null;
      }
    },
    range: {
      type: Boolean,
      default: false
    },
    selection: {
      type: String,
      default: 'before'
    },
    tooltip: {
      type: String,
      default: 'show'
    },
    tooltipSplit: {
      type: Boolean,
      default: false
    },
    tooltipPosition: {
      type: String
    },
    handle: {
      type: String,
      default: 'round'
    },
    reversed: {
      type: Boolean,
      default: false
    },
    rtl: {
      type: String,
      default: 'auto'
    },
    formatter: {
      type: Function
    },
    naturalArrowKeys: {
      type: Boolean,
      default: false
    },
    ticks: {
      type: Array,
      default: function _default() {
        return [];
      }
    },
    ticksPositions: {
      type: Array,
      default: function _default() {
        return [];
      }
    },
    ticksLabels: {
      type: Array,
      default: function _default() {
        return [];
      }
    },
    ticksSnapBounds: {
      type: Number,
      default: 0
    },
    ticksTooltip: {
      type: Boolean,
      default: false
    },
    scale: {
      type: String,
      default: 'linear'
    },
    focus: {
      type: Boolean,
      default: false
    },
    labelledby: {
      type: [String, Array],
      default: function _default() {
        return null;
      }
    },
    rangeHighlights: {
      type: Array,
      default: function _default() {
        return [];
      }
    },
    disabled: {
      type: Boolean,
      default: false
    },
    triggerSlideEvent: {
      type: Boolean,
      default: false
    },
    triggerChangeEvent: {
      type: Boolean,
      default: false
    },
    debounce: {
      type: Number,
      default: 0
    }
  }
};
exports.props = props;
var watch = {
  watch: {
    min: function min(value, oldValue) {
      if (this.slider && value !== oldValue) {
        this.slider.setAttribute('min', value);
        this.refresh();
      }
    },
    max: function max(value, oldValue) {
      if (this.slider && value !== oldValue) {
        this.slider.setAttribute('max', value);
        this.refresh();
      }
    },
    step: function step(value, oldValue) {
      if (this.slider && value !== oldValue) {
        this.slider.setAttribute('step', value);
        this.refresh();
      }
    },
    precision: function precision(value, oldValue) {
      if (this.slider && value !== oldValue) {
        this.slider.setAttribute('precision', value);
        this.refresh();
      }
    },
    orientation: function orientation(value, oldValue) {
      if (this.slider && value !== oldValue) {
        this.slider.setAttribute('orientation', value);
        this.refresh();
      }
    },
    range: function range(value, oldValue) {
      if (this.slider && value !== oldValue) {
        this.slider.setAttribute('range', value);
        this.refresh();
      }
    },
    selection: function selection(value, oldValue) {
      if (this.slider && value !== oldValue) {
        this.slider.setAttribute('selection', value);
        this.refresh();
      }
    },
    tooltip: function tooltip(value, oldValue) {
      if (this.slider && value !== oldValue) {
        this.slider.setAttribute('tooltip', value);
        this.refresh();
      }
    },
    tooltipSplit: function tooltipSplit(value, oldValue) {
      if (this.slider && value !== oldValue) {
        this.slider.setAttribute('tooltipSplit', value);
        this.refresh();
      }
    },
    tooltipPosition: function tooltipPosition(value, oldValue) {
      if (this.slider && value !== oldValue) {
        this.slider.setAttribute('tooltipPosition', value);
        this.refresh();
      }
    },
    handle: function handle(value, oldValue) {
      if (this.slider && value !== oldValue) {
        this.slider.setAttribute('handle', value);
        this.refresh();
      }
    },
    reversed: function reversed(value, oldValue) {
      if (this.slider && value !== oldValue) {
        this.slider.setAttribute('reversed', value);
        this.refresh();
      }
    },
    rtl: function rtl(value, oldValue) {
      if (this.slider && value !== oldValue) {
        this.slider.setAttribute('rtl', value);
        this.refresh();
      }
    },
    formatter: function formatter(value, oldValue) {
      if (this.slider && value !== oldValue) {
        this.slider.setAttribute('formatter', value);
        this.refresh();
      }
    },
    naturalArrowKeys: function naturalArrowKeys(value, oldValue) {
      if (this.slider && value !== oldValue) {
        this.slider.setAttribute('naturalArrowKeys', value);
        this.refresh();
      }
    },
    ticks: function ticks(value, oldValue) {
      if (this.slider) {
        this.slider.setAttribute('ticks', value);
        this.refresh();
      }
    },
    ticksPositions: function ticksPositions(value, oldValue) {
      if (this.slider) {
        this.slider.setAttribute('ticksPositions', value);
        this.refresh();
      }
    },
    ticksLabels: function ticksLabels(value, oldValue) {
      if (this.slider) {
        this.slider.setAttribute('ticksLabels', value);
        this.refresh();
      }
    },
    ticksSnapBounds: function ticksSnapBounds(value, oldValue) {
      if (this.slider && value !== oldValue) {
        this.slider.setAttribute('ticksSnapBounds', value);
        this.refresh();
      }
    },
    ticksTooltip: function ticksTooltip(value, oldValue) {
      if (this.slider && value !== oldValue) {
        this.slider.setAttribute('ticksTooltip', value);
        this.refresh();
      }
    },
    scale: function scale(value, oldValue) {
      if (this.slider && value !== oldValue) {
        this.slider.setAttribute('scale', value);
        this.refresh();
      }
    },
    focus: function focus(value, oldValue) {
      if (this.slider && value !== oldValue) {
        this.slider.setAttribute('focus', value);
        this.refresh();
      }
    },
    labelledby: function labelledby(value, oldValue) {
      if (this.slider) {
        this.slider.setAttribute('labelledby', value);
        this.refresh();
      }
    },
    rangeHighlights: function rangeHighlights(value, oldValue) {
      if (this.slider) {
        this.slider.setAttribute('rangeHighlights', value);
        this.refresh();
      }
    },
    disabled: function disabled(value) {
      if (value) {
        this.slider.disable();
      } else {
        this.slider.enable();
      }
    },
    value: function value(_value) {
      this.slider.setValue(_value, this.triggerSlideEvent, this.triggerChangeEvent);
    }
  }
};
exports.watch = watch;
var _default2 = props;
exports.default = _default2;